#property copyright "Speed Tick (c) HotFx 2011.09.29"
#property link "http://hot-fx.blogspot.com" // http://hotfx.0pk.ru
#property indicator_separate_window
#property indicator_buffers 1
#property indicator_color1 White
#property indicator_style1 STYLE_DOT

extern int TickPer       =  30;  //max 60
extern double Speed      =  2.0;
extern string SoundStop  =  "wait.wav";
extern string SoundTrnd  =  "news.wav";
double MyPoint, snd, lot, prvPrice, arrTick[60], x[];
datetime prvTime; int pnt;

void init()
 {
  MyPoint = Point / 10; if (Digits == 5 || Digits == 3) MyPoint *= 10;
  SetIndexStyle(0, DRAW_LINE); SetIndexBuffer(0, x);
  ObjectCreate("tick", OBJ_LABEL, 0, 0, 0);
  ObjectSet("tick", OBJPROP_CORNER, 1);
  ObjectSet("tick", OBJPROP_XDISTANCE, 20);
  ObjectSet("tick", OBJPROP_YDISTANCE, 250);
  ArrayInitialize(arrTick, 0);
 }
  
void start() 
 { 
  ArrayCopy(x, x, 1, 0, 1000); x[0] = Close[0]; datetime curTime = TimeCurrent(); if (curTime == prvTime) prvTime --;
  double curSpeed = (Close[0] - prvPrice) / (curTime - prvTime); prvTime = curTime; prvPrice = Close[0];
  
  double avgSpd = 0; arrTick[pnt] = curSpeed; pnt ++; if (pnt == TickPer) pnt = 0;
  for (int i = 0; i < TickPer; i ++) avgSpd = avgSpd + arrTick[i];
  avgSpd = NormalizeDouble(avgSpd / TickPer / MyPoint, 2); 
 
  ObjectSetText("tick", DoubleToStr(avgSpd, 2) , 23, "Impact");

  if (avgSpd > 0) ObjectSet("tick", OBJPROP_COLOR, Blue);
  if (avgSpd == 0) ObjectSet("tick", OBJPROP_COLOR, Gold);
  if (avgSpd < 0) ObjectSet("tick", OBJPROP_COLOR, Red);

  if (avgSpd >=  Speed && snd !=  Speed) { snd =  Speed; if ( SoundTrnd != "") PlaySound(SoundTrnd); }
  if (avgSpd <= -Speed && snd != -Speed) { snd = -Speed; if ( SoundTrnd != "") PlaySound(SoundTrnd); }

  if ( (avgSpd <= 0 && snd ==  Speed) || (avgSpd >= 0 && snd == -Speed) ) { snd = 0; if ( SoundStop != "") PlaySound(SoundStop); }
 }

